/*
	Little Smalltalk, version 3
	Net Console Driver
	written By Eiichiro Ito, April 2010
	Yamanashi Gakuin University
*/
# include <stdio.h>
# include "env.h"
# include "memory.h"
# include "names.h"
#include "netconsole.h"
#include <stdlib.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netdb.h>
#include <string.h>

int cofd = -1;
struct sockaddr_in sv_addr, co_addr;
#define PORT_NO 54001

void
nc_start()
{
  int len, val;
  int sofd = socket( AF_INET, SOCK_STREAM, 0 );
  if ( sofd < 0 ) {
    perror("socket");
    exit(1);
  }
  bzero( &sv_addr, sizeof sv_addr );
  sv_addr.sin_family = AF_INET;
  sv_addr.sin_addr.s_addr = INADDR_ANY;
  sv_addr.sin_port = htons(PORT_NO);
  val = 1;
  setsockopt( sofd, SOL_SOCKET, SO_REUSEADDR, &val, sizeof (val) );
  if ( bind( sofd, (struct sockaddr *) &sv_addr, sizeof sv_addr ) < 0 ) {
    perror("bind");
    exit(1);
  }
  fprintf( stderr, "[Waiting connection]\n" );
  if ( listen( sofd, 1 ) == -1 ) {
    perror("listen");
    exit(1);
  }
  cofd = accept( sofd, (struct sockaddr *) &co_addr, &len );
  if ( cofd < 0 ) {
    perror("accept");
    exit(1);
  }
  fprintf( stderr, "[Connection opened]\n" );
  close( sofd );
  val = 1;
  ioctl( cofd, FIONBIO, &val );
  send( cofd, "Hello.", 6, 0 );
}
