* RMBoard Control Classes
Class KHR1 Object poses home
Methods KHR1 'initialization'
	init
		<160>.
		<161>.
		<163>.
		poses <- Dictionary new
|
	readPoses	| file line |
		file <- File new; name: 'poses.txt'; mode: 'r'; open.
		[(line <- file getString) notNil]
		      whileTrue: [self addPoseFrom: line].
		file close.
|
	addPoseFrom: line	| a sym pose x |
		a <- line value.
		sym <- a at: 1.
		pose <- a at: 2.
		(sym == #home) ifTrue: [
		    home <- pose copy.
		    (1 to: 24)
		       do: [:i |
		       	   x <- (pose at: i) * 90 / 255.
			   pose at: i put: x floor]
		] ifFalse: [
		    (1 to: 24)
		       do: [:i |
		       	   x <- ((home at: i) + (pose at: i)) * 90 / 255.
			   pose at: i put: x floor]
		].
		poses at: sym put: pose.
|
	moveTo: aSymbol		| pose |
		pose <- poses at: aSymbol ifAbsent: ['unknown pose' print. ^ self].
		(1 to: 24)
		   do: [:i | self servoAt: (i - 1) degrees: (pose at: i) ].
		<164>
|
	setHome
		self moveTo: #home.
		<162>
|
	servoAt: num degrees: degrees
		 <165 num (degrees floor)>
|
	poses
		^ poses
|
	home
		^ home
]
