* RMBoard Control Classes
Class KHR1 Object speed walkCycle
Class Body Object
Class Leg Object ankleAdjust
Class   LeftLeg Leg
Class   RightLeg Leg
Class Hand Object
Class   LeftHand Hand
Class   RightHand Hand
Class Head Object
Methods KHR1 'initialization'
	init
		<160>.
		<180>.
		speed <- 50.
		body <- Body new.
		left <- LeftLeg new.
		right <- RightLeg new.
		leftH <- LeftHand new.
		rightH <- RightHand new.
		head <- Head new.
		trim <- [body hip: 0; waist: 0; squat: 0].
		home <- [body hip: 0; waist: 0; squat: 50].
		ballx <- 0.
		ballfound <- false.
|
	reset
		<161>
|
	setPWM
		<162>
|
	trim
		<174 1>.
		<164>.
		self setPWM
|
	initNext
		<169>
|
	servoAt: num put: degrees
		<170 (num - 1) (degrees floor)>
|
	servoAt: num
		 ^ <171 (num - 1)>
|
	moveNext: num
		[<172 num> = 0] whileTrue: [<164>]
|
	speed
		^ speed
|
	speed: num
	       speed <- num floor
|
	syncSpeed: num
		<173 num>
|
	sync
		self syncSpeed: speed
|
	sync: aBlock
	        aBlock value.
		self syncSpeed: speed
|
	on
		self init.
		self trim.
		self sync: home
|
	off
		left groin: 0; knee: 0.
		right groin: 0; knee: 0.
		khr sync.
		khr reset
|
	ch1: degrees
		<170 0 (degrees floor)>
|
	ch2: degrees
		<170 1 (degrees floor)>
|
	ch3: degrees
		<170 2 (degrees floor)>
|
	ch4: degrees
		<170 3 (degrees floor)>
|
	ch5: degrees
		<170 4 (degrees floor)>
|
	ch6: degrees
		<170 5 (degrees floor)>
|
	ch7: degrees
		<170 6 (degrees floor)>
|
	ch8: degrees
		<170 7 (degrees floor)>
|
	ch9: degrees
		<170 8 (degrees floor)>
|
	ch10: degrees
		<170 9 (degrees floor)>
|
	ch11: degrees
		<170 10 (degrees floor)>
|
	ch12: degrees
		<170 11 (degrees floor)>
|
	ch13: degrees
		<170 12 (degrees floor)>
|
	ch14: degrees
		<170 13 (degrees floor)>
|
	ch15: degrees
		<170 14 (degrees floor)>
|
	ch16: degrees
		<170 15 (degrees floor)>
|
	ch17: degrees
		<170 16 (degrees floor)>
|
	ch18: degrees
		<170 17 (degrees floor)>
|
	ch19: degrees
		<170 18 (degrees floor)>
|
	ch20: degrees
		<170 19 (degrees floor)>
|
	ch21: degrees
		<170 20 (degrees floor)>
|
	sensorAt: num
		^ <168 (num - 1)>
|
	newSession
		[[true] whileTrue: [(smalltalk getPrompt: '!') value print]]
			forkWithID: 0
|
	printValue: v tag: tag
		('@', tag asString, ':', v asString) printLn
|
	swAt: aNum	| x |
		x <- <190 (aNum floor)>.
		^ x = 0
|
	ledNo: aNum on: aBoolean
	       <191 aNum (aBoolean ifTrue: [1] ifFalse: [0])>
|
	sleep: num
	       <182 (num floor)>
]
Methods Body 'accessing'
	hip: angle
		left hip: angle.
		right hip: angle negated.
|
	waist: angle
		khr servoAt: 10 put: angle.
		khr servoAt: 16 put: angle
|
	squat: angle
	       left squat: angle.
	       right squat: angle
|
	walk: num
	      num timesRepeat: [
	      	  self walkLeft; walkRight ]
|
	rightStep
		body hip: -10.
		scheduler yield.
		scheduler yield.
		left hip: -5.
		right hip: 15.
		right squat: 10.
		scheduler yield.
		scheduler yield.
		body hip: 10.
		scheduler yield.
		scheduler yield.
		right squat: 0.
		scheduler yield.
		scheduler yield.
|
	leftStep
		body hip: 12.
		scheduler yield.
		scheduler yield.
		right hip: -5.
		left hip: 12.
		left squat: 10.
		scheduler yield.
		scheduler yield.
		body hip: -10.
		scheduler yield.
		scheduler yield.
		left squat: 0.
		scheduler yield.
		scheduler yield.
|
	stretchHands: angle
		leftH stretch: angle.
		rightH stretch: angle
|
	home
		body hip: 0; squat: 0; waist: 0
|
	hiraku: angle
		left hip: angle.
		right hip: angle.
|
	tojiru
		khr speed: 150.
		self uchimata: 0.
		body squat: 60.
		scheduler yield.
		scheduler yield.
		body hip: 0.
		khr speed: 100.
		scheduler yield.
		scheduler yield.
		body squat: 0.
|
	shootLeft
		body hip: 12.
		khr syncSpeed: 20.
		left squat: 30.
		body hip: 16.
		khr sync.
		left groin: 50.
		khr servoAt: 20 put: -2.
		khr sync.
		left knee: 0.
		khr syncSpeed: 200.
		left knee: 60.
		khr servoAt: 20 put: 0.
		khr sync.
		left squat: 0.
		khr sync.
		body hip: 0.
		khr syncSpeed: 20
|
	uchimata: angle
		khr servoAt: 10 put: angle negated.
		khr servoAt: 16 put: angle.
]
Methods Leg 'accessing'
	new
		self ankleAdjust: 2.
|
	ankleAdjust: num
		ankleAdjust <- num.
|
	groin: angle		| knee |
		knee <- khr servoAt: self chKnee.
		khr servoAt: self chGroin put: angle.
		khr servoAt: self chAnkle put: (knee - angle + ankleAdjust).
|
	knee: angle		| groin |
		groin <- khr servoAt: self chGroin.
		khr servoAt: self chKnee put: angle.
		khr servoAt: self chAnkle put: (angle - groin + ankleAdjust).
|
	hip: angle
		khr servoAt: self chHip put: angle.
		khr servoAt: self chHeel put: angle.
|
	squat: angle
		self groin: angle; knee: angle * 2
]
Methods LeftLeg 'accessing'
	chHip
		^ 11
|
	chGroin
		^ 12
|
	chKnee
		^ 13
|
	chAnkle
		^ 14
|
	chHeel
		^ 15
]
Methods RightLeg 'accessing'
	chHip
		^ 17
|
	chGroin
		^ 18
|
	chKnee
		^ 19
|
	chAnkle
		^ 20
|
	chHeel
		^ 21
]
Methods Head 'accessing'
	chNeck
		^ 1
|
	pointAt: num
		^ <181 num>
|
	neck: angle
	      khr servoAt: self chNeck put: angle
|
	look: num	| point x |
	      point <- self pointAt: num.
	      ballsize <- point at: 3.
	      ballsize < 5 ifTrue: [ballfound <- false. ^ self].
	      x <- (point at: 1) - 300.
	      ballx <- (x // 8) + (khr servoAt: self chNeck).
	      self neck: ballx.
	      ballfound <- true
]
Methods Hand 'accessing'
	stretch: angle
		khr servoAt: self chArm put: angle.
]
Methods LeftHand 'accessing'
	chShoulder
		^ 2
|
	chArm
		^ 3
|
	chElbow
		^ 4
]
Methods RightHand 'accessing'
	chShoulder
		^ 6
|
	chArm
		^ 7
|
	chElbow
		^ 8
]
Methods KHR1 'autonomous'
	start
		self trim.
		[[khr sync. scheduler yield] repeat] fork.
		[body home.
		 body stretchHands: 30.
		 scheduler yield.
		 scheduler yield.
		 khr ledNo: 1 on: true.
		 khr ledNo: 2 on: true.
		 self sleep: 5.
		 [(self swAt: 1) or: [self swAt: 2]] whileFalse.
		 khr ledNo: 1 on: false.
		 khr ledNo: 2 on: false.
		 self sleep: 20.
		 self mainLoop] repeat.
|
	mainLoop
		sitDown <- false.
		[(self swAt: 1) or: [self swAt: 2]] whileFalse:
		 [head look: 1.
		  scheduler yield.
		  scheduler yield.
		  ballfound
		   ifTrue: [
		    sitDown
		     ifTrue: [
		      ballsize < 50
		       ifTrue: [
		        body tojiru. sitDown <- false ]]
		     ifFalse: [
		      ballsize > 150
		       ifTrue: [
		        self mamoru.
			sitDown <- true ]]]
		   ifFalse: [head neck: 0].
		  scheduler yield.
		  scheduler yield ]
|
	mamoru
		khr speed: 150.
		body hiraku: 10.
		body squat: 60.
]
